"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = observeStore;
function observeStore(_ref, select, onChange) {
  var getState = _ref.getState,
      subscribe = _ref.subscribe;

  var currentState = void 0;

  function handleChange() {
    var nextState = select(getState());
    if (nextState !== currentState) {
      var prevState = currentState;
      currentState = nextState;
      onChange(currentState, prevState);
    }
  }

  var unsubscribe = subscribe(handleChange);
  handleChange();
  return unsubscribe;
}